/********************************** (C) COPYRIGHT *******************************
 * File Name          : iap.c
 * Author             : WCH
 * Version            : V1.0
 * Date               : 2022/03/15
 * Description        : UART IAP
 *********************************************************************************
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * Attention: This software (modified or not) and binary are used for 
 * microcontroller manufactured by Nanjing Qinheng Microelectronics.
 *******************************************************************************/
#include "iap.h"

/* ȨޣȲҲַҪAPPӦַһ²ſɸȨ */
uint8_t g_update_permition = 0;

uint8_t iap_rec_data_state = IAP_DATA_REC_STATE_WAIT_SOP1, all_data_rec_cnt = 0, part_rec_cnt = 0, uart_rec_sign = 0;

iap_cmd_t iap_rec_data;

__attribute__((aligned(4)))                    uint8_t g_write_buf[256 + 64];

uint16_t g_buf_write_ptr = 0;

uint32_t g_flash_write_ptr = 0;

uint32_t g_tcnt;

uint32_t g_addr;

__attribute__((aligned(4)))   uint8_t iap_rsp_data[6] = {IAP_DATA_SOP1, IAP_DATA_SOP2, 0, 0, IAP_DATA_EOP1, IAP_DATA_EOP2};

/*********************************************************************
 * @fn      Main_Circulation
 *
 * @brief   IAPѭ,ramУٶ.
 *
 * @param   None.
 *
 * @return  None.
 */
__attribute__((section(".highcode")))
void Main_Circulation()
{
    while (1)
    {
        /* òѯģʽʹжϣٴռflash */
        if (R8_UART1_RFC)
        {
            /* ݣλڴڽչ̱־λ */
            uart_rec_sign = 1;
            /* ݣճʱʱ */
            g_tcnt = 0;
            /* ռһ洢buf */
            all_data_rec_cnt++;
            /* bufԽ */
            if (all_data_rec_cnt >= sizeof(iap_rec_data))
            {
                all_data_rec_cnt = 0;
            }
            /* ȡڼĴݣֱӸֵbufУжֵԽԼflashռ */
            iap_rec_data.other.buf[all_data_rec_cnt] = R8_UART1_RBR;
            /*
             * Ϊ˽ԼռÿռʹٶȣӦĴü
             * Ӧø룬УֵͰβϢ浽ӦĽṹchecksumeopԱС
             * ĴΪֱӰ˳洢bufУ
             * ݳȲΪݳʱͨṹʳԱchecksumeop᲻ȷ
             * û޸ʱע⡣
             * ÿζݰж˵ÿζԼ˶жʱ䡢flashռ䡣
             */
            switch (iap_rec_data_state) /* ݽ״̬ݵĶȡжϺʹ洢 */
            {
            /* ״̬ڵȴͷ1ʱжϽյֽǷΪIAP_DATA_SOP1 */
            case IAP_DATA_REC_STATE_WAIT_SOP1:
                if (iap_rec_data.other.buf[all_data_rec_cnt] == IAP_DATA_SOP1)
                {
                    /* ֻеһֽʱһ洢bufȷλã´洢 */
                    iap_rec_data.other.buf[0] = iap_rec_data.other.buf[all_data_rec_cnt];
                    /* ռʼ */
                    all_data_rec_cnt = 0;
                    iap_rec_data_state = IAP_DATA_REC_STATE_WAIT_SOP2;
                }
                break;
            /* ״̬ڵȴͷ2ʱжϽյֽǷΪIAP_DATA_SOP2 */
            case IAP_DATA_REC_STATE_WAIT_SOP2:
                if (iap_rec_data.other.buf[all_data_rec_cnt] == IAP_DATA_SOP2)
                {
                    iap_rec_data_state = IAP_DATA_REC_STATE_WAIT_CMD;
                }
                else
                {
                    iap_rec_data_state = IAP_DATA_REC_STATE_WAIT_SOP1;
                }
                break;
            /* ״̬ڵȴʱжϽյֽǷΪϷcmd */
            case IAP_DATA_REC_STATE_WAIT_CMD:
                if ((iap_rec_data.other.buf[all_data_rec_cnt] < CMD_IAP_PROM) || (iap_rec_data.other.buf[all_data_rec_cnt] > CMD_IAP_END))
                {
                    /* error ûcmd */
                    iap_rec_data_state = IAP_DATA_REC_STATE_WAIT_SOP1;
                }
                else
                {
                    iap_rec_data_state = IAP_DATA_REC_STATE_WAIT_LEN;
                }
                break;
            /* ״̬ڵȴݳʱжϽյֽǷΪϷĳ */
            case IAP_DATA_REC_STATE_WAIT_LEN:
                if (iap_rec_data.other.buf[all_data_rec_cnt] <= IAP_LEN)
                {
                    /* ղֽṹֽ */
                    part_rec_cnt = 0;
                    if ((iap_rec_data.other.buf[2] == CMD_IAP_ERASE) || (iap_rec_data.other.buf[2] == CMD_IAP_VERIFY))
                    {
                        iap_rec_data_state = IAP_DATA_REC_STATE_WAIT_ADDR;
                    }
                    else
                    {
                        /* жݳǷΪ0Ϊ0ֱӽУ*/
                        if (iap_rec_data.other.buf[3] > 0)
                        {
                            iap_rec_data_state = IAP_DATA_REC_STATE_WAIT_DATA;
                        }
                        else
                        {
                            iap_rec_data_state = IAP_DATA_REC_STATE_WAIT_CHECKNUM;
                        }
                    }
                }
                else
                {
                    iap_rec_data_state = IAP_DATA_REC_STATE_WAIT_SOP1;
                }
                break;
            /* ״̬ڵȴַʱ */
            case IAP_DATA_REC_STATE_WAIT_ADDR:
                part_rec_cnt++;
                /* ַΪ4ֽڣյ4תһ״̬ */
                if (part_rec_cnt >= 4)
                {
                    /* ֽṹֽ */
                    part_rec_cnt = 0;
                    if (iap_rec_data.other.buf[3] > 0)
                    {
                        iap_rec_data_state = IAP_DATA_REC_STATE_WAIT_DATA;
                    }
                    else
                    {
                        iap_rec_data_state = IAP_DATA_REC_STATE_WAIT_CHECKNUM;
                    }
                }
                break;
            /* ״̬ڵȴʱ */
            case IAP_DATA_REC_STATE_WAIT_DATA:
                part_rec_cnt++;
                if (part_rec_cnt >= iap_rec_data.other.buf[3])
                {
                    /* жǷ*/
                    iap_rec_data_state = IAP_DATA_REC_STATE_WAIT_CHECKNUM;
                    /* ֽṹֽ */
                    part_rec_cnt = 0;
                }
                break;
            /* ״̬ڵȴУʱ */
            case IAP_DATA_REC_STATE_WAIT_CHECKNUM:
                part_rec_cnt++;
                if (part_rec_cnt >= 2)
                {
                    /* жУǷɣУΪ2ֽںУ*/
                    iap_rec_data_state = IAP_DATA_REC_STATE_WAIT_EOP1;
                }
                break;
            /* ״̬ڵȴβ1ʱжϽյֽǷΪIAP_DATA_EOP1 */
            case IAP_DATA_REC_STATE_WAIT_EOP1:
                if (iap_rec_data.other.buf[all_data_rec_cnt] == IAP_DATA_EOP1)
                {
                    iap_rec_data_state = IAP_DATA_REC_STATE_WAIT_EOP2;
                }
                else
                {
                    iap_rec_data_state = IAP_DATA_REC_STATE_WAIT_SOP1;
                }
                break;
            /* ״̬ڵȴβ2ʱжϽյֽǷΪIAP_DATA_EOP2 */
            case IAP_DATA_REC_STATE_WAIT_EOP2:
                if (iap_rec_data.other.buf[all_data_rec_cnt] == IAP_DATA_EOP2)
                {
                    iap_rec_data_state = IAP_DATA_REC_STATE_OK;
                }
                else
                {
                    iap_rec_data_state = IAP_DATA_REC_STATE_WAIT_SOP1;
                }
                break;
            default:
                /* һ㲻ܳ */
                break;
            }

            if (iap_rec_data_state == IAP_DATA_REC_STATE_OK)
            {
                /* У */
                uint16_t   check_num = 0, check_num_rec;
                /* Уͼ */
                uint16_t   check_num_i;
                /* ϱΪĬ޴״̬ */
                iap_rsp_data[2] = 0x00;
                iap_rsp_data[3] = 0x00;
                /* ָĬϵ״̬ */
                iap_rec_data_state = IAP_DATA_REC_STATE_WAIT_SOP1;
                /* һݰͷſмʱ */
                uart_rec_sign = 0;
                g_tcnt = 0;
                /* У */
                for (check_num_i = 2; check_num_i < all_data_rec_cnt - 3; check_num_i++)
                {
                    check_num += iap_rec_data.other.buf[check_num_i];
                }
                check_num_rec = iap_rec_data.other.buf[check_num_i] | (iap_rec_data.other.buf[check_num_i + 1] << 8);
                /* ݰУͨ */
                if (check_num_rec == check_num)
                {
                    /* ж */
                    switch (iap_rec_data.other.buf[2])
                    {
                    /* д */
                    case CMD_IAP_PROM:
                        /* жǷȲоƬ */
                        if (g_update_permition == 1)
                        {
                            if (iap_rec_data.program.len == 0)
                            {
                                /* һΪհΪһ */
                                if (g_buf_write_ptr != 0)
                                {
                                    if (FLASH_ROM_WRITE(g_flash_write_ptr, (PUINT32)g_write_buf, g_buf_write_ptr))
                                    {
                                        iap_rsp_data[2] = 0xfe;
                                        iap_rsp_data[3] = IAP_ERR_WRITE_FAIL;
                                    }
                                    g_buf_write_ptr = 0;
                                }
                            }
                            else
                            {
                                my_memcpy(g_write_buf + g_buf_write_ptr, iap_rec_data.program.data, iap_rec_data.program.len);
                                g_buf_write_ptr += iap_rec_data.program.len;
                                if (g_buf_write_ptr >= 256)
                                {
                                    /* 256ֽдһ */
                                    if (FLASH_ROM_WRITE(g_flash_write_ptr, (PUINT32)g_write_buf, 256))
                                    {
                                        iap_rsp_data[2] = 0xfe;
                                        iap_rsp_data[3] = IAP_ERR_WRITE_FAIL;
                                        break;
                                    }
                                    /* ƶָ */
                                    g_flash_write_ptr += 256;
                                    /* ¼㳬ĳȣݿײ */
                                    g_buf_write_ptr = g_buf_write_ptr - 256;
                                    my_memcpy(g_write_buf, g_write_buf + 256, g_buf_write_ptr);
                                }
                            }
                        }
                        else
                        {
                            /* ûв裬ɸ£ */
                            iap_rsp_data[2] = 0xfe;
                            iap_rsp_data[3] = IAP_ERR_PROG_NO_ERASE;
                        }
                        break;
                    /*  */
                    case CMD_IAP_ERASE:
                        if (iap_rec_data.erase.addr == APP_CODE_START_ADDR)
                        {
                            /* 󣬿޸Ĳĳȣһflashų */
                            if (FLASH_ROM_ERASE(APP_CODE_START_ADDR, APP_CODE_END_ADDR - APP_CODE_START_ADDR) == 0)
                            {
                                /* ʼַȷȨޣΪʧ */
                                g_update_permition = 1;
                                /* 㣬flashдָ */
                                g_buf_write_ptr = 0;
                                g_flash_write_ptr = APP_CODE_START_ADDR;
                            }
                            else
                            {
                                /* ʧ */
                                iap_rsp_data[2] = 0xfe;
                                iap_rsp_data[3] = IAP_ERR_ERASE_FAIL;
                            }
                        }
                        else
                        {
                            /* ַ */
                            iap_rsp_data[2] = 0xfe;
                            iap_rsp_data[3] = IAP_ERR_ADDR;
                        }
                        break;
                    /* У */
                    case CMD_IAP_VERIFY:
                        if (((iap_rec_data.verify.addr % 4) == 0) && (iap_rec_data.verify.addr >= APP_CODE_START_ADDR) && (iap_rec_data.verify.addr < APP_CODE_END_ADDR))
                        {
                            my_memcpy(g_write_buf, iap_rec_data.verify.data, iap_rec_data.verify.len);
                            if (FLASH_ROM_VERIFY(iap_rec_data.verify.addr, g_write_buf, iap_rec_data.verify.len))
                            {
                                /* Уʧܣ */
                                iap_rsp_data[2] = 0xfe;
                                iap_rsp_data[3] = IAP_ERR_VERIFY;
                            }
                        }
                        else
                        {
                            /* Уַ */
                            iap_rsp_data[2] = 0xfe;
                            iap_rsp_data[3] = IAP_ERR_ADDR;
                        }
                        break;
                    /* ת */
                    case CMD_IAP_END:
                        jumpApp();
                        break;
                    default:
                        /* ʱжΪֵԲָ */
                        iap_rsp_data[2] = 0xfe;
                        iap_rsp_data[3] = IAP_ERR_UNKNOWN;
                        break;
                    }
                    if (iap_rsp_data[2] != 0)
                    {
                        /* УͨոȨޣҪ£¿ʼ */
                        g_update_permition = 0;
                    }
                }
                else
                {
                    /* ݰУʧܣѡطݰӰ */
                    iap_rsp_data[2] = 0xfe;
                    iap_rsp_data[3] = IAP_ERR_CHECK;
                }
                /* ÿݰ꣬ջݣֹЩģżȻ෢һַźţһһظ */
                while (R8_UART1_RFC)
                {
                    iap_rec_data.other.buf[all_data_rec_cnt] = R8_UART1_RBR;
                }
                /* ظ */
                UART1_SendString(iap_rsp_data, sizeof(iap_rsp_data));
            }
        }
        else
        {
            /* ӳ115200´ķ֮һֽڵʱ䣬ͶȡĴƵʺʱ䣬㳬ʱ޸ĲʣҲصʱ */
            DelayUs(20);
            g_tcnt++;
            if (uart_rec_sign)
            {
                if (g_tcnt >= 43)
                {
                    /* 10ֽڿʱûֽڵûһݰͳʱݲ޸ */
                    /* ĿǰΪ115200,һֽʱΪ1s/11520 = 87us, 87us*10 / 20us = 43.5 */
                    /* ѡطݰӰ */
                    iap_rec_data_state = IAP_DATA_REC_STATE_WAIT_SOP1;
                    uart_rec_sign = 0;
                    iap_rsp_data[2] = 0xfe;
                    iap_rsp_data[3] = IAP_ERR_OVERTIME;
                    UART1_SendString(iap_rsp_data, sizeof(iap_rsp_data));
                }
            }
            else
            {
                if (g_tcnt > 6000000)
                {
                    /* 120ûݣΪʱapp޸ */
                    jumpApp();
                }
            }
        }
    }
}


/*********************************************************************
 * @fn      my_memcpy
 *
 * @brief   ݿ,ramУٶ
 *
 * @param   None.
 *
 * @return  None.
 */
__attribute__((section(".highcode")))
void my_memcpy(void *dst, const void *src, uint32_t l)
{
    uint32_t len = l;
    PUINT8 pdst = (PUINT8) dst;
    PUINT8 psrc = (PUINT8) src;
    while (len)
    {
        *pdst++ = *psrc++;
        len--;
    }
}
