/********************************** (C) COPYRIGHT *******************************
 * File Name          : CH58x_usbhost.c
 * Author             : WCH
 * Version            : V1.2
 * Date               : 2021/11/17
 * Description
 *********************************************************************************
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * Attention: This software (modified or not) and binary are used for 
 * microcontroller manufactured by Nanjing Qinheng Microelectronics.
 *******************************************************************************/

#include "CH58x_common.h"
#if DISK_LIB_ENABLE
  #include "CHRV3UFI.H"
#endif

uint8_t       Usb2DevEndp0Size; // USB2豸Ķ˵0ߴ
uint8_t       FoundNewU2Dev;
_RootHubDev   ThisUsb2Dev;                   //ROOT
_DevOnHubPort DevOnU2HubPort[HUB_MAX_PORTS]; // ٶ:1ⲿHUB,ÿⲿHUBHUB_MAX_PORTS˿(˲)

uint8_t *pU2HOST_RX_RAM_Addr;
uint8_t *pU2HOST_TX_RAM_Addr;

/*ȡ豸*/
__attribute__((aligned(4))) const uint8_t SetupGetU2DevDescr[] = {USB_REQ_TYP_IN, USB_GET_DESCRIPTOR, 0x00,
                                                                  USB_DESCR_TYP_DEVICE, 0x00, 0x00, sizeof(USB_DEV_DESCR), 0x00};
/*ȡ*/
__attribute__((aligned(4))) const uint8_t SetupGetU2CfgDescr[] = {USB_REQ_TYP_IN, USB_GET_DESCRIPTOR, 0x00,
                                                                  USB_DESCR_TYP_CONFIG, 0x00, 0x00, 0x04, 0x00};
/*USBַ*/
__attribute__((aligned(4))) const uint8_t SetupSetUsb2Addr[] = {USB_REQ_TYP_OUT, USB_SET_ADDRESS, USB_DEVICE_ADDR,
                                                                0x00, 0x00, 0x00, 0x00, 0x00};
/*USB*/
__attribute__((aligned(4))) const uint8_t SetupSetUsb2Config[] = {USB_REQ_TYP_OUT, USB_SET_CONFIGURATION,
                                                                  0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
/*USBӿ*/
__attribute__((aligned(4))) const uint8_t SetupSetUsb2Interface[] = {USB_REQ_RECIP_INTERF, USB_SET_INTERFACE,
                                                                     0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
/*˵STALL*/
__attribute__((aligned(4))) const uint8_t SetupClrU2EndpStall[] = {USB_REQ_TYP_OUT | USB_REQ_RECIP_ENDP, USB_CLEAR_FEATURE,
                                                                   0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

/*********************************************************************
 * @fn      DisableRootU2HubPort
 *
 * @brief   رROOT-HUB˿,ʵӲѾԶر,˴ֻһЩṹ״̬
 *
 * @param   none
 *
 * @return  none
 */
void DisableRootU2HubPort(void)
{
#ifdef FOR_ROOT_UDISK_ONLY
    CHRV3DiskStatus = DISK_DISCONNECT;
#endif
#ifndef DISK_BASE_BUF_LEN
    ThisUsb2Dev.DeviceStatus = ROOT_DEV_DISCONNECT;
    ThisUsb2Dev.DeviceAddress = 0x00;
#endif
}

/*********************************************************************
 * @fn      AnalyzeRootU2Hub
 *
 * @brief   ROOT-HUB״̬,ROOT-HUB˿ڵ豸¼
 *          豸γ,еDisableRootHubPort(),˿ڹر,¼,Ӧ˿ڵ״̬λ
 *
 * @param   none
 *
 * @return  ERR_SUCCESSΪû,ERR_USB_CONNECTΪ⵽,ERR_USB_DISCONΪ⵽Ͽ
 */
uint8_t AnalyzeRootU2Hub(void)
{
    uint8_t s;

    s = ERR_SUCCESS;

    if(R8_USB2_MIS_ST & RB_UMS_DEV_ATTACH)
    { // 豸
#ifdef DISK_BASE_BUF_LEN
        if(CHRV3DiskStatus == DISK_DISCONNECT
#else
        if(ThisUsb2Dev.DeviceStatus == ROOT_DEV_DISCONNECT // ⵽豸
#endif
           || (R8_U2HOST_CTRL & RB_UH_PORT_EN) == 0x00)
        {                           // ⵽豸,δ,˵Ǹղ
            DisableRootU2HubPort(); // رն˿
#ifdef DISK_BASE_BUF_LEN
            CHRV3DiskStatus = DISK_CONNECT;
#else
            ThisUsb2Dev.DeviceSpeed = R8_USB2_MIS_ST & RB_UMS_DM_LEVEL ? 0 : 1;
            ThisUsb2Dev.DeviceStatus = ROOT_DEV_CONNECTED; //ӱ־
#endif
            PRINT("USB2 dev in\n");
            s = ERR_USB_CONNECT;
        }
    }

#ifdef DISK_BASE_BUF_LEN
    else if(CHRV3DiskStatus >= DISK_CONNECT)
    {
#else
    else if(ThisUsb2Dev.DeviceStatus >= ROOT_DEV_CONNECTED)
    { //⵽豸γ
#endif
        DisableRootU2HubPort(); // رն˿
        PRINT("USB2 dev out\n");
        if(s == ERR_SUCCESS)
            s = ERR_USB_DISCON;
    }
    //  R8_USB_INT_FG = RB_UIF_DETECT;                                                  // жϱ־
    return (s);
}

/*********************************************************************
 * @fn      SetHostUsb2Addr
 *
 * @brief   USBǰUSB豸ַ
 *
 * @param   addr    - USB豸ַ
 *
 * @return  none
 */
void SetHostUsb2Addr(uint8_t addr)
{
    R8_USB2_DEV_AD = (R8_USB2_DEV_AD & RB_UDA_GP_BIT) | (addr & MASK_USB_ADDR);
}

/*********************************************************************
 * @fn      SetUsb2Speed
 *
 * @brief   õǰUSBٶ
 *
 * @param   FullSpeed   - USBٶ
 *
 * @return  none
 */
void SetUsb2Speed(uint8_t FullSpeed)
{
#ifndef DISK_BASE_BUF_LEN
    if(FullSpeed) // ȫ
    {
        R8_USB2_CTRL &= ~RB_UC_LOW_SPEED;  // ȫ
        R8_U2H_SETUP &= ~RB_UH_PRE_PID_EN; // ֹPRE PID
    }
    else
    {
        R8_USB2_CTRL |= RB_UC_LOW_SPEED; // 
    }
#endif
    (void)FullSpeed;
}

/*********************************************************************
 * @fn      ResetRootU2HubPort
 *
 * @brief   ⵽豸,λ,Ϊö豸׼,ΪĬΪȫ
 *
 * @param   none
 *
 * @return  none
 */
void ResetRootU2HubPort(void)
{
    Usb2DevEndp0Size = DEFAULT_ENDP0_SIZE; //USB2豸Ķ˵0ߴ
    SetHostUsb2Addr(0x00);
    R8_U2HOST_CTRL &= ~RB_UH_PORT_EN;                                       // ص˿
    SetUsb2Speed(1);                                                        // ĬΪȫ
    R8_U2HOST_CTRL = (R8_U2HOST_CTRL & ~RB_UH_LOW_SPEED) | RB_UH_BUS_RESET; // ĬΪȫ,ʼλ
    mDelaymS(15);                                                           // λʱ10mS20mS
    R8_U2HOST_CTRL = R8_U2HOST_CTRL & ~RB_UH_BUS_RESET;                     // λ
    mDelayuS(250);
    R8_USB2_INT_FG = RB_UIF_DETECT; // жϱ־
}

/*********************************************************************
 * @fn      EnableRootU2HubPort
 *
 * @brief   ʹROOT-HUB˿,ӦbUH_PORT_EN1˿,豸Ͽܵ·ʧ
 *
 * @param   none
 *
 * @return  ERR_SUCCESSΪ⵽,ERR_USB_DISCONΪ
 */
uint8_t EnableRootU2HubPort(void)
{
#ifdef DISK_BASE_BUF_LEN
    if(CHRV3DiskStatus < DISK_CONNECT)
        CHRV3DiskStatus = DISK_CONNECT;
#else
    if(ThisUsb2Dev.DeviceStatus < ROOT_DEV_CONNECTED)
        ThisUsb2Dev.DeviceStatus = ROOT_DEV_CONNECTED;
#endif
    if(R8_USB2_MIS_ST & RB_UMS_DEV_ATTACH)
    { // 豸
#ifndef DISK_BASE_BUF_LEN
        if((R8_U2HOST_CTRL & RB_UH_PORT_EN) == 0x00)
        { // δʹ
            ThisUsb2Dev.DeviceSpeed = (R8_USB2_MIS_ST & RB_UMS_DM_LEVEL) ? 0 : 1;
            if(ThisUsb2Dev.DeviceSpeed == 0)
                R8_U2HOST_CTRL |= RB_UH_LOW_SPEED; // 
        }
#endif
        R8_U2HOST_CTRL |= RB_UH_PORT_EN; //ʹHUB˿
        return (ERR_SUCCESS);
    }
    return (ERR_USB_DISCON);
}

#ifndef DISK_BASE_BUF_LEN
/*********************************************************************
 * @fn      SelectU2HubPort
 *
 * @brief   ѡҪHUB
 *
 * @param   HubPortIndex    - ѡָROOT-HUB˿ڵⲿHUBָ˿
 *
 * @return  None
 */
void SelectU2HubPort(uint8_t HubPortIndex)
{
    if(HubPortIndex) // ѡָROOT-HUB˿ڵⲿHUBָ˿
    {
        SetHostUsb2Addr(DevOnU2HubPort[HubPortIndex - 1].DeviceAddress); // USBǰUSB豸ַ
        SetUsb2Speed(DevOnU2HubPort[HubPortIndex - 1].DeviceSpeed);      // õǰUSBٶ
        if(DevOnU2HubPort[HubPortIndex - 1].DeviceSpeed == 0)            // ͨⲿHUBUSB豸ͨѶҪǰID
        {
            R8_U2EP1_CTRL |= RB_UH_PRE_PID_EN; // PRE PID
            mDelayuS(100);
        }
    }
    else
    {
        SetHostUsb2Addr(ThisUsb2Dev.DeviceAddress); // USBǰUSB豸ַ
        SetUsb2Speed(ThisUsb2Dev.DeviceSpeed);      // USB豸ٶ
    }
}
#endif

/*********************************************************************
 * @fn      WaitUSB2_Interrupt
 *
 * @brief   ȴUSBж
 *
 * @param   none
 *
 * @return  ERR_SUCCESS ݽջ߷ͳɹ,ERR_USB_UNKNOWN ݽջ߷ʧ
 */
uint8_t WaitUSB2_Interrupt(void)
{
    uint16_t i;
    for(i = WAIT_USB_TOUT_200US; i != 0 && (R8_USB2_INT_FG & RB_UIF_TRANSFER) == 0; i--)
    {
        ;
    }
    return ((R8_USB2_INT_FG & RB_UIF_TRANSFER) ? ERR_SUCCESS : ERR_USB_UNKNOWN);
}

/*********************************************************************
 * @fn      USB2HostTransact
 *
 * @brief   ,ĿĶ˵ַ/PID,ͬ־,20uSΪλNAKʱ(0,0xFFFF),0ɹ,ʱ/
 *          ӳ,ʵӦ,Ϊṩٶ,ӦöԱӳŻ
 *
 * @param   endp_pid    - ƺ͵ַ, 4λtoken_pid, 4λǶ˵ַ
 * @param   tog         - ͬ־
 * @param   timeout     - ʱʱ
 *
 * @return  ERR_USB_UNKNOWN ʱӲ쳣
 *          ERR_USB_DISCON  豸Ͽ
 *          ERR_USB_CONNECT 豸
 *          ERR_SUCCESS     
 */
uint8_t USB2HostTransact(uint8_t endp_pid, uint8_t tog, uint32_t timeout)
{
    uint8_t TransRetry;

    uint8_t  s, r;
    uint16_t i;

    R8_U2H_RX_CTRL = R8_U2H_TX_CTRL = tog;
    TransRetry = 0;

    do
    {
        R8_U2H_EP_PID = endp_pid; // ָPIDĿĶ˵
        R8_USB2_INT_FG = RB_UIF_TRANSFER;
        for(i = WAIT_USB_TOUT_200US; i != 0 && (R8_USB2_INT_FG & RB_UIF_TRANSFER) == 0; i--)
            ;
        R8_U2H_EP_PID = 0x00; // ֹͣUSB
        if((R8_USB2_INT_FG & RB_UIF_TRANSFER) == 0)
        {
            return (ERR_USB_UNKNOWN);
        }

        if(R8_USB2_INT_FG & RB_UIF_DETECT)
        { // USB豸¼
            //      mDelayuS( 200 );                                                       // ȴ
            R8_USB2_INT_FG = RB_UIF_DETECT;
            s = AnalyzeRootU2Hub(); // ROOT-U2HUB״̬

            if(s == ERR_USB_CONNECT)
                FoundNewU2Dev = 1;
#ifdef DISK_BASE_BUF_LEN
            if(CHRV3DiskStatus == DISK_DISCONNECT)
            {
                return (ERR_USB_DISCON);
            } // USB豸Ͽ¼
            if(CHRV3DiskStatus == DISK_CONNECT)
            {
                return (ERR_USB_CONNECT);
            } // USB豸¼
#else
            if(ThisUsb2Dev.DeviceStatus == ROOT_DEV_DISCONNECT)
            {
                return (ERR_USB_DISCON);
            } // USB豸Ͽ¼
            if(ThisUsb2Dev.DeviceStatus == ROOT_DEV_CONNECTED)
            {
                return (ERR_USB_CONNECT);
            } // USB豸¼
#endif
            mDelayuS(200); // ȴ
        }

        if(R8_USB2_INT_FG & RB_UIF_TRANSFER) // ¼
        {
            if(R8_USB2_INT_ST & RB_UIS_TOG_OK)
            {
                return (ERR_SUCCESS);
            }
            r = R8_USB2_INT_ST & MASK_UIS_H_RES; // USB豸Ӧ״̬
            if(r == USB_PID_STALL)
            {
                return (r | ERR_USB_TRANSFER);
            }
            if(r == USB_PID_NAK)
            {
                if(timeout == 0)
                {
                    return (r | ERR_USB_TRANSFER);
                }
                if(timeout < 0xFFFFFFFF)
                    timeout--;
                --TransRetry;
            }
            else
                switch(endp_pid >> 4)
                {
                    case USB_PID_SETUP:
                    case USB_PID_OUT:
                        if(r)
                        {
                            return (r | ERR_USB_TRANSFER);
                        }      // ǳʱ/,Ӧ
                        break; // ʱ
                    case USB_PID_IN:
                        if(r == USB_PID_DATA0 || r == USB_PID_DATA1)
                        { // ͬ趪
                        } // ͬ
                        else if(r)
                        {
                            return (r | ERR_USB_TRANSFER);
                        }      // ǳʱ/,Ӧ
                        break; // ʱ
                    default:
                        return (ERR_USB_UNKNOWN); // ܵ
                        break;
                }
        }
        else
        {                          // ж,Ӧ÷
            R8_USB2_INT_FG = 0xFF; /* жϱ־ */
        }
        mDelayuS(15);
    } while(++TransRetry < 3);
    return (ERR_USB_TRANSFER); // Ӧʱ
}

/*********************************************************************
 * @fn      U2HostCtrlTransfer
 *
 * @brief   ִпƴ,8ֽpSetupReq,DataBufΪѡշ
 *
 * @param   DataBuf     - Ҫպͷ,ôDataBufָЧڴź
 * @param   RetLen      - ʵʳɹշܳȱRetLenָֽڱ
 *
 * @return  ERR_USB_BUF_OVER    IN״̬׶γ
 *          ERR_SUCCESS         ݽɹ
 */
uint8_t U2HostCtrlTransfer(uint8_t *DataBuf, uint8_t *RetLen)
{
    uint16_t RemLen = 0;
    uint8_t  s, RxLen, RxCnt, TxCnt;
    uint8_t *pBuf;
    uint8_t *pLen;

    pBuf = DataBuf;
    pLen = RetLen;
    mDelayuS(200);
    if(pLen)
        *pLen = 0; // ʵʳɹշܳ

    R8_U2H_TX_LEN = sizeof(USB_SETUP_REQ);
    s = USB2HostTransact(USB_PID_SETUP << 4 | 0x00, 0x00, 200000 / 20); // SETUP׶,200mSʱ
    if(s != ERR_SUCCESS)
        return (s);
    R8_U2H_RX_CTRL = R8_U2H_TX_CTRL = RB_UH_R_TOG | RB_UH_R_AUTO_TOG | RB_UH_T_TOG | RB_UH_T_AUTO_TOG; // ĬDATA1
    R8_U2H_TX_LEN = 0x01;                                                                              // Ĭݹ״̬׶ΪIN
    RemLen = pU2SetupReq->wLength;
    if(RemLen && pBuf) // Ҫշ
    {
        if(pU2SetupReq->bRequestType & USB_REQ_TYP_IN) // 
        {
            while(RemLen)
            {
                mDelayuS(200);
                s = USB2HostTransact(USB_PID_IN << 4 | 0x00, R8_U2H_RX_CTRL, 200000 / 20); // IN
                if(s != ERR_SUCCESS)
                    return (s);
                RxLen = R8_USB2_RX_LEN < RemLen ? R8_USB2_RX_LEN : RemLen;
                RemLen -= RxLen;
                if(pLen)
                    *pLen += RxLen; // ʵʳɹշܳ
                for(RxCnt = 0; RxCnt != RxLen; RxCnt++)
                {
                    *pBuf = pU2HOST_RX_RAM_Addr[RxCnt];
                    pBuf++;
                }
                if(R8_USB2_RX_LEN == 0 || (R8_USB2_RX_LEN & (Usb2DevEndp0Size - 1)))
                    break; // ̰
            }
            R8_U2H_TX_LEN = 0x00; // ״̬׶ΪOUT
        }
        else // 
        {
            while(RemLen)
            {
                mDelayuS(200);
                R8_U2H_TX_LEN = RemLen >= Usb2DevEndp0Size ? Usb2DevEndp0Size : RemLen;
                for(TxCnt = 0; TxCnt != R8_U2H_TX_LEN; TxCnt++)
                {
                    pU2HOST_TX_RAM_Addr[TxCnt] = *pBuf;
                    pBuf++;
                }
                s = USB2HostTransact(USB_PID_OUT << 4 | 0x00, R8_U2H_TX_CTRL, 200000 / 20); // OUT
                if(s != ERR_SUCCESS)
                    return (s);
                RemLen -= R8_U2H_TX_LEN;
                if(pLen)
                    *pLen += R8_U2H_TX_LEN; // ʵʳɹշܳ
            }
            //          R8_U2H_TX_LEN = 0x01;                                                     // ״̬׶ΪIN
        }
    }
    mDelayuS(200);
    s = USB2HostTransact((R8_U2H_TX_LEN ? USB_PID_IN << 4 | 0x00 : USB_PID_OUT << 4 | 0x00), RB_UH_R_TOG | RB_UH_T_TOG, 200000 / 20); // STATUS׶
    if(s != ERR_SUCCESS)
        return (s);
    if(R8_U2H_TX_LEN == 0)
        return (ERR_SUCCESS); // ״̬OUT
    if(R8_USB2_RX_LEN == 0)
        return (ERR_SUCCESS);  // ״̬IN,IN״̬ݳ
    return (ERR_USB_BUF_OVER); // IN״̬׶δ
}

/*********************************************************************
 * @fn      CopyU2SetupReqPkg
 *
 * @brief   ƿƴ
 *
 * @param   pReqPkt     - ַ
 *
 * @return  none
 */
void CopyU2SetupReqPkg(const uint8_t *pReqPkt) // ƿƴ
{
    uint8_t i;
    for(i = 0; i != sizeof(USB_SETUP_REQ); i++)
    {
        ((uint8_t *)pU2SetupReq)[i] = *pReqPkt;
        pReqPkt++;
    }
}

/*********************************************************************
 * @fn      CtrlGetU2DeviceDescr
 *
 * @brief   ȡ豸, pHOST_TX_RAM_Addr 
 *
 * @param   none
 *
 * @return  ERR_USB_BUF_OVER    ȴ
 *          ERR_SUCCESS         ɹ
 */
uint8_t CtrlGetU2DeviceDescr(void)
{
    uint8_t s;
    uint8_t len;

    Usb2DevEndp0Size = DEFAULT_ENDP0_SIZE;
    CopyU2SetupReqPkg((uint8_t *)SetupGetU2DevDescr);
    s = U2HostCtrlTransfer(U2Com_Buffer, &len); // ִпƴ
    if(s != ERR_SUCCESS)
        return (s);
    Usb2DevEndp0Size = ((PUSB_DEV_DESCR)U2Com_Buffer)->bMaxPacketSize0; // ˵0,Ǽ򻯴,ӦȻȡǰ8ֽںUsbDevEndp0Sizeټ
    if(len < ((PUSB_SETUP_REQ)SetupGetU2DevDescr)->wLength)
        return (ERR_USB_BUF_OVER); // ȴ
    return (ERR_SUCCESS);
}

/*********************************************************************
 * @fn      CtrlGetU2ConfigDescr
 *
 * @brief   ȡ, pHOST_TX_RAM_Addr 
 *
 * @param   none
 *
 * @return  ERR_USB_BUF_OVER    ȴ
 *          ERR_SUCCESS         ɹ
 */
uint8_t CtrlGetU2ConfigDescr(void)
{
    uint8_t s;
    uint8_t len;

    CopyU2SetupReqPkg((uint8_t *)SetupGetU2CfgDescr);
    s = U2HostCtrlTransfer(U2Com_Buffer, &len); // ִпƴ
    if(s != ERR_SUCCESS)
        return (s);
    if(len < ((PUSB_SETUP_REQ)SetupGetU2CfgDescr)->wLength)
        return (ERR_USB_BUF_OVER); // سȴ

    len = ((PUSB_CFG_DESCR)U2Com_Buffer)->wTotalLength;
    CopyU2SetupReqPkg((uint8_t *)SetupGetU2CfgDescr);
    pU2SetupReq->wLength = len;                 // ܳ
    s = U2HostCtrlTransfer(U2Com_Buffer, &len); // ִпƴ
    if(s != ERR_SUCCESS)
        return (s);

#ifdef DISK_BASE_BUF_LEN
    if(len > 64)
        len = 64;
    memcpy(TxBuffer, U2Com_Buffer, len); //U̲ʱҪTxBuffer
#endif

    return (ERR_SUCCESS);
}

/*********************************************************************
 * @fn      CtrlSetUsb2Address
 *
 * @brief   USB豸ַ
 *
 * @param   addr    - 豸ַ
 *
 * @return  ERR_SUCCESS     ɹ
 */
uint8_t CtrlSetUsb2Address(uint8_t addr)
{
    uint8_t s;

    CopyU2SetupReqPkg((uint8_t *)SetupSetUsb2Addr);
    pU2SetupReq->wValue = addr;         // USB豸ַ
    s = U2HostCtrlTransfer(NULL, NULL); // ִпƴ
    if(s != ERR_SUCCESS)
        return (s);
    SetHostUsb2Addr(addr); // USBǰUSB豸ַ
    mDelaymS(10);          // ȴUSB豸ɲ
    return (ERR_SUCCESS);
}

/*********************************************************************
 * @fn      CtrlSetUsb2Config
 *
 * @brief   USB豸
 *
 * @param   cfg     - ֵ
 *
 * @return  ERR_SUCCESS     ɹ
 */
uint8_t CtrlSetUsb2Config(uint8_t cfg)
{
    CopyU2SetupReqPkg((uint8_t *)SetupSetUsb2Config);
    pU2SetupReq->wValue = cfg;               // USB豸
    return (U2HostCtrlTransfer(NULL, NULL)); // ִпƴ
}

/*********************************************************************
 * @fn      CtrlClearU2EndpStall
 *
 * @brief   ˵STALL
 *
 * @param   endp    - ˵ַ
 *
 * @return  ERR_SUCCESS     ɹ
 */
uint8_t CtrlClearU2EndpStall(uint8_t endp)
{
    CopyU2SetupReqPkg((uint8_t *)SetupClrU2EndpStall); // ˵Ĵ
    pU2SetupReq->wIndex = endp;                        // ˵ַ
    return (U2HostCtrlTransfer(NULL, NULL));           // ִпƴ
}

/*********************************************************************
 * @fn      CtrlSetUsb2Intercace
 *
 * @brief   USB豸ӿ
 *
 * @param   cfg     - ֵ
 *
 * @return  ERR_SUCCESS     ɹ
 */
uint8_t CtrlSetUsb2Intercace(uint8_t cfg)
{
    CopyU2SetupReqPkg((uint8_t *)SetupSetUsb2Interface);
    pU2SetupReq->wValue = cfg;               // USB豸
    return (U2HostCtrlTransfer(NULL, NULL)); // ִпƴ
}

/*********************************************************************
 * @fn      USB2_HostInit
 *
 * @brief   USBܳʼ
 *
 * @param   none
 *
 * @return  none
 */
void USB2_HostInit(void)
{
    R8_USB2_CTRL = RB_UC_HOST_MODE;
    R8_U2HOST_CTRL = 0;
    R8_USB2_DEV_AD = 0x00;

    R8_U2H_EP_MOD = RB_UH_EP_TX_EN | RB_UH_EP_RX_EN;
    R16_U2H_RX_DMA = (uint16_t)(uint32_t)pU2HOST_RX_RAM_Addr;
    R16_U2H_TX_DMA = (uint16_t)(uint32_t)pU2HOST_TX_RAM_Addr;

    R8_U2H_RX_CTRL = 0x00;
    R8_U2H_TX_CTRL = 0x00;
    R8_USB2_CTRL = RB_UC_HOST_MODE | RB_UC_INT_BUSY | RB_UC_DMA_EN;
    R8_U2H_SETUP = RB_UH_SOF_EN;
    R8_USB2_INT_FG = 0xFF;
    DisableRootU2HubPort();
    R8_USB2_INT_EN = RB_UIE_TRANSFER | RB_UIE_DETECT;

    FoundNewU2Dev = 0;
}
