/********************************** (C) COPYRIGHT *******************************
 * File Name          : Main.c
 * Author             : WCH
 * Version            : V1.1
 * Date               : 2022/01/25
 * Description        : USB2豸ö
 *********************************************************************************
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * Attention: This software (modified or not) and binary are used for 
 * microcontroller manufactured by Nanjing Qinheng Microelectronics.
 *******************************************************************************/

#include "CH58x_common.h"

__attribute__((aligned(4))) uint8_t RxBuffer[MAX_PACKET_SIZE]; // IN, must even address
__attribute__((aligned(4))) uint8_t TxBuffer[MAX_PACKET_SIZE]; // OUT, must even address

/*********************************************************************
 * @fn      main
 *
 * @brief   
 *
 * @return  none
 */
int main()
{
    uint8_t i, s, k, len, endp;
    uint16_t  loc;

    SetSysClock(CLK_SOURCE_PLL_60MHz);
    DelayMs(5);
    /* ѹ */
    PowerMonitor(ENABLE, HALevel_2V1);

    GPIOA_SetBits(GPIO_Pin_9);
    GPIOA_ModeCfg(GPIO_Pin_8, GPIO_ModeIN_PU);
    GPIOA_ModeCfg(GPIO_Pin_9, GPIO_ModeOut_PP_5mA);
    UART1_DefInit();
    PRINT("Start @ChipID=%02X\n", R8_CHIP_ID);

    pU2HOST_RX_RAM_Addr = RxBuffer;
    pU2HOST_TX_RAM_Addr = TxBuffer;
    USB2_HostInit();
    PRINT("Wait Device In\n");
    while(1)
    {
        s = ERR_SUCCESS;
        if(R8_USB2_INT_FG & RB_UIF_DETECT)
        { // USBж
            R8_USB2_INT_FG = RB_UIF_DETECT;
            s = AnalyzeRootU2Hub();
            if(s == ERR_USB_CONNECT)
                FoundNewU2Dev = 1;
        }

        if(FoundNewU2Dev || s == ERR_USB_CONNECT)
        { // µUSB豸
            FoundNewU2Dev = 0;
            mDelaymS(200);          // USB豸ղδȶ,ʵȴUSB豸ٺ,ζ
            s = InitRootU2Device(); // ʼUSB豸
            if(s != ERR_SUCCESS)
            {
                PRINT("EnumAllRootDev err = %02X\n", (uint16_t)s);
            }
        }

        /* ¶ӵHUBöHUB */
        s = EnumAllU2HubPort(); // öROOT-HUB˿ⲿHUBĶUSB豸
        if(s != ERR_SUCCESS)
        { // HUBϿ
            PRINT("EnumAllHubPort err = %02X\n", (uint16_t)s);
        }

        /* 豸 */
        loc = U2SearchTypeDevice(DEV_TYPE_MOUSE); // ROOT-HUBԼⲿHUB˿ָ͵豸ڵĶ˿ں
        if(loc != 0xFFFF)
        { // ҵ,MOUSEδ?
            i = (uint8_t)(loc >> 8);
            len = (uint8_t)loc;
            SelectU2HubPort(len);                                                 // ѡָROOT-HUB˿,õǰUSBٶԼ豸USBַ
            endp = len ? DevOnU2HubPort[len - 1].GpVar[0] : ThisUsb2Dev.GpVar[0]; // ж϶˵ĵַ,λ7ͬ־λ
            if(endp & USB_ENDP_ADDR_MASK)
            {                                                                                                        // ˵Ч
                s = USB2HostTransact(USB_PID_IN << 4 | endp & 0x7F, endp & 0x80 ? RB_UH_R_TOG | RB_UH_T_TOG : 0, 0); // ,ȡ,NAK
                if(s == ERR_SUCCESS)
                {
                    endp ^= 0x80; // ͬ־ת
                    if(len)
                        DevOnU2HubPort[len - 1].GpVar[0] = endp; // ͬ־λ
                    else
                        ThisUsb2Dev.GpVar[0] = endp;
                    len = R8_USB2_RX_LEN; // յݳ
                    if(len)
                    {
                        PRINT("Mouse data: ");
                        for(i = 0; i < len; i++)
                        {
                            PRINT("x%02X ", (uint16_t)(RxBuffer[i]));
                        }
                        PRINT("\n");
                    }
                }
                else if(s != (USB_PID_NAK | ERR_USB_TRANSFER))
                {
                    PRINT("Mouse error %02x\n", (uint16_t)s); // ǶϿ
                }
            }
            else
            {
                PRINT("Mouse no interrupt endpoint\n");
            }
            SetUsb2Speed(1); // ĬΪȫ??
        }

        /* 豸Ǽ */
        loc = U2SearchTypeDevice(DEV_TYPE_KEYBOARD); // ROOT-HUBԼⲿHUB˿ָ͵豸ڵĶ˿ں
        if(loc != 0xFFFF)
        { // ҵ,KeyBoardδ?
            i = (uint8_t)(loc >> 8);
            len = (uint8_t)loc;
            SelectU2HubPort(len);                                                 // ѡָROOT-HUB˿,õǰUSBٶԼ豸USBַ
            endp = len ? DevOnU2HubPort[len - 1].GpVar[0] : ThisUsb2Dev.GpVar[0]; // ж϶˵ĵַ,λ7ͬ־λ
            if(endp & USB_ENDP_ADDR_MASK)
            {                                                                                                        // ˵Ч
                s = USB2HostTransact(USB_PID_IN << 4 | endp & 0x7F, endp & 0x80 ? RB_UH_R_TOG | RB_UH_T_TOG : 0, 0); // ,ȡ,NAK
                if(s == ERR_SUCCESS)
                {
                    endp ^= 0x80; // ͬ־ת
                    if(len)
                        DevOnU2HubPort[len - 1].GpVar[0] = endp; // ͬ־λ
                    else
                        ThisUsb2Dev.GpVar[0] = endp;
                    len = R8_USB2_RX_LEN; // յݳ
                    if(len)
                    {
                        U2SETorOFFNumLock(RxBuffer);
                        PRINT("keyboard data: ");
                        for(i = 0; i < len; i++)
                        {
                            PRINT("x%02X ", (uint16_t)(RxBuffer[i]));
                        }
                        PRINT("\n");
                    }
                }
                else if(s != (USB_PID_NAK | ERR_USB_TRANSFER))
                {
                    PRINT("keyboard error %02x\n", (uint16_t)s); // ǶϿ
                }
            }
            else
            {
                PRINT("keyboard no interrupt endpoint\n");
            }
            SetUsb2Speed(1); // ĬΪȫ
        }
    }
}
